function [ H, scale, params, approx, Hb, res] = MYRON_Algo(X, K, ops)
tic
ops.mu = 0;
scale = ones(1,K);
dim = length(size(X)); nn = size(X);
U = cell( dim, 1 );
Ub = cell(dim,1);
H = ops.Hinit;
Hb = ops.Binit;
Xb = ktensor(1,Hb);
for d = 1:dim
    scale_d = max(H{d});
    scale = scale.*scale_d;
    H{d} = H{d}./scale_d;
    U{d} = zeros( nn(d),K);
    Ub{d} = zeros(nn(d),1);
end
GG = cell( dim, 1 );
GGb = cell(dim, 1);
for d = 1:dim
    GG{d} = H{d}'*H{d};
    GGb{d} = Hb{d}'*Hb{d};
end
ops.B = cell(3,1);
ops.B{3} = zeros(size(H{3}));
if strcmp(ops.shape,'bursty')
    params = ops.params;
else
    params=[];
end
normX = norm(X);
for itr = 1:ops.maxitr
    
    
    %%
    %Fit community factors
    for d = 1:dim
        [ H, scale, U, GG, i ] = doFactor( X, Xb, H,scale, U, d, GG, ops);
        res.admm(d,itr) = i;
        if strcmp(ops.constraint{d},'shape') && strcmp(ops.shape,'bursty')
%             scale_ = scale.^ops.scaleP;
            [params, ops.B{3}]=fitparams(H{3}', params);
        elseif strcmp(ops.constraint{d},'shape') && strcmp(ops.shape,'wavelet')
%             scale_ = scale.^ops.scaleP;
            if strcmp(ops.wavelet,'mat')
                [params,ops.B{3}]=matwav(H{3},ops);
            else
                [params, ops.B{3}]=wavelet(H{3}, ops);
            end
        end
    end
    %%
    %Fit "global" factor
    if strcmp(ops.global,'fullA') 
        [Hb,s_,Ub,GGb,~] = doFactor(X,ktensor(scale',H),Hb,1,Ub,1,GGb,ops.opsB);
        Hb{3} = Hb{3}.*s_;
        [Hb,s_,Ub,GGb,~] = doFactor(X,ktensor(scale',H),Hb,1,Ub,2,GGb,ops.opsB);
        Hb{3} = Hb{3}.*s_;
        [Hb,s_,Ub,GGb,~] = doFactor(X,ktensor(scale',H),Hb,1,Ub,3,GGb,ops.opsB);
        Hb{3} = Hb{3}.*s_;
        Xb = ktensor(1,Hb);
    elseif strcmp(ops.global,'resmean')
        Hb{3}=ones(nn(3),1)*(collapse(X)-sum(arrayfun(@(k) sum(H{1}(:,k))*sum(H{2}(:,k))*sum(H{3}(:,k))*scale(k),1:K)))/prod(size(X));
        Xb = ktensor(1,Hb);
    end
    %%
    res.time(itr) = toc;
    res.err(itr) = Loss( X, H,scale,normX);
    %%
    %GROUND TRUTH SPECIFIC
    if isfield(ops,'ground')
        cand.C = H{1}; 
        [~,em] = evalMatch(cand,ops.ground);
        res.fit(itr) = em;
    end
    %%
    ops.mu = 1e-7 + .1*res.err(itr);

    if toc > ops.maxtime || ( itr>1 && ...
                abs( res.err(itr) - res.err(itr-1) ) < ops.tol )
        res.err(itr+1:end) = [];
        res.time(itr+1:end) = [];
        res.admm(:,itr+1:end) = [];
        break; 
    end
end
approx = ops.B{3};
end

function [ H, scale, U, GG, itr ] = doFactor( X, Xb, H,scale, U, d, GG, ops)
% ADMM iterates to solve
%       minimize (1/2)*|| Y - ktensor(H) ||^2 + r(H{d})
% for sparse tensor factorization
%   Y is the sptensor
%   H is a cell of the matrix factors
%   d is the index of the matrix factor to be updated

K = length(scale);
% size(Y)
% size(H{d})
% d
G = scale'*scale; prod = [ 1:d-1, d+1:length(GG) ];
for dd = prod
    G = G .* GG{dd}; 
end
rho = min(1e-3,trace(G)/K);
L = chol( G + (rho+ops.mu)*eye(K), 'lower' );
Htemp=H;
Htemp{prod(1)}=Htemp{prod(1)}.*scale;
F = mttkrp( X, Htemp, d ) - mttkrp(Xb,Htemp,d);
tol = 1e-4;
Hd = H{d}; Ud = U{d};
if ~isfield(ops, 'maxitrAO')
    maxitr = 5;
else
    maxitr=ops.maxitrAO;
end
for itr = 1:maxitr
    H0 = Hd;
    
    Ht   = L'\ ( L\ ( F + rho*(Hd+Ud) + ops.mu*H{d} )' );
%     Hd = proxr( Ht'-Ud, ops, d, rho, Hd);
    if strcmp(ops.constraint{d},'nonnegative')
        Hd = max(0,Ht'-Ud);
    elseif strcmp(ops.constraint{d},'shape')
        Hd = max(0, 1/(ops.la+rho/2)*(ops.la*ops.B{d} + rho/2*(Ht'-Ud)));
    end
    Ud = Ud + Hd - Ht';
    
    r = Hd - Ht';
    s = Hd - H0;
    if norm(r(:)) < tol*norm(Hd(:)) && norm(s(:)) < tol*norm(Ud(:))
        break
    end
end
if max(Hd)>0
    scale = scale.*max(Hd);
end
if max(Hd)>0
    s_ = max(Hd);
else
    s_=1;
end
H{d} = Hd./s_;
U{d} = Ud;
GG{d} = H{d}'*H{d};
end

function [params, A]=fitparams(Nt,params)
    EPSILON = .001;
    T = size(Nt,2)-1;
    K = size(Nt,1);
    NT = sum(Nt, 2);
    xi = zeros(K,T+1);
    for itr = 1:50
        old = [params.ab, params.a0, params.g, params.b];
        for t=2:T+1
            xi(:,t)=xi(:,t-1).*params.b+Nt(:,t-1);
        end
        bt = cell2mat(arrayfun(@(t) params.b.^t,0:T,'UniformOutput',false));
        btxi = sum(xi.*bt,2);
        b1_b = (1-params.b.^T)./(1-params.b) - (1-params.b.^(2*T))./(1-params.b.^2);
        Ntbt = sum(Nt.*bt,2);
        params.ab = max(0,(NT - Ntbt - params.a0.*b1_b - params.g.*sum(xi,2) + params.g.*btxi)./(b1_b+T-(1-params.b.^T)./(1-params.b)));
        params.a0 = max(0,(1-params.b.^2).*(Ntbt - params.ab.*b1_b - params.g.*btxi)./(1-params.b.^(2*T)));
        params.g = max(0,(sum(Nt.*xi,2) - params.ab.*(sum(xi,2)-btxi)-params.a0.*btxi)./sum(xi.*xi,2));

        params.b = min(1,max(0,arrayfun(@(k) fminsearch(@(b) objective(b, Nt(k,:),params.ab(k), params.a0(k), params.g(k)),params.b(k)),(1:K)')));
        TD = sum(sum(abs(old - [params.ab, params.a0, params.g, params.b])));
        if TD < EPSILON
            break;
        end
    end
    
    A = zeros(K,T+1);
    A(:,1) = params.a0;
    for t=2:T+1
        A(:,t) = params.ab + (A(:,t-1)-params.ab).*params.b + params.g.*Nt(:,t-1);
    end
    A = A';
end

function [params,A] = wavelet(Nt,ops)
    K = size(Nt, 2);
    A = zeros(size(Nt));
    params{K} = [];
    for k = 1:K
        [c,l]=wavedec(Nt(:,k),ops.N,ops.wavelet);
        
        [~,i] = sort(abs(c),'descend');
        thresh = ceil(length(c)*ops.thresh);
        c(i(thresh:end))=0;
        params{k} = c;
        A(:,k) = waverec(c,l,ops.wavelet);
    end
end

function [params,A] = matwav(Nt,ops)
    B = WaveletMatrix_nL(length(Nt),log2(length(Nt)),'haar');
    params = lasso(B,Nt,ops.l);
    A = B*params;
end

function err = Loss( X, H, scale, normY )
    if ~isa( X, 'sptensor' )
        H{3} = H{3}.*scale;
        err = normY^2 + norm( ktensor(H) )^2 ...
            - 2*innerprod( tensor(X), ktensor(H) );
        err = sqrt(err)/normY;
    elseif  isa( X, 'sptensor' )
        err = normY^2 + norm( ktensor(H) )^2 ...
            - 2*innerprod( X, ktensor(H) );
        err = sqrt(err)/normY;
    end
end
