
function [K_est,K_est2,K_est3,K_est4] = MYRON_CCD(X,Kmin,Kmax, Uthresh, ops)

	allF = Kmin:Kmax;
	all_Fac_fro = {};
	all_Fac_fro2= {};
    thresh = 20;

	all_c_fro = zeros(length(allF),1);
	all_c_fro2= zeros(length(allF),1);

	for f = allF
	   [fac,~, his ] = BRC( X, f, ops );
       Fac{1} = fac{1};
       Fac{2} = fac{2};
       Fac2 = Fac;
       Fac{3} = fac{3};
       Fac2{3} = fac{7};


	   [c_fro, idx1] = time_warped_CCD(X,Fac, fac{4}, Uthresh);
       [c_fro2, idx2] = time_warped_CCD(X,Fac2, fac{4}, Uthresh);
	   
       o.constraint = {'nonnegative','nonnegative','nonnegative'};
       o.noReg = 1;  
       o.dense=0;


       all_c_fro(find(f == allF)) = c_fro;
	   all_Fac_fro{find(f == allF)} = Fac;
       all_c_fro2(find(f ==allF)) = c_fro2;
	   all_Fac_fro2{find(f == allF)} = Fac2;
	end

	all_c_fro(all_c_fro<thresh) = 0;
	all_c_fro2(all_c_fro2<thresh) = 0;
	[K_est, ~] = multi_objective_optim(allF,all_c_fro);
    [K_est2, ~] = multi_objective_optim(allF,all_c_fro2);
	fprintf('Estimated ranks K are : %d %d\n',K_est,K_est2);
end


function [x_best, y_best] = multi_objective_optim(x,y)
    %clustering heuristic method
    try
        clusters = kmeans(y,2,'Distance','cityblock');
    catch %if an error is thrown, then an empty cluster is formed, so then we just assign all elements to cluster 1
        disp('Empty cluster!!')
        clusters = ones(size(y));
        clusters(y>0)=2;
    end
    cent1 = mean(y(clusters == 1));
    cent2 = mean(y(clusters == 2));
    [maxval, cent_idx] = max([cent1 cent2]);
    x_to_choose = x(clusters == cent_idx);
    [x_best,x_idx] = max(x_to_choose);
    y_best = y(x == x_best);
end
function [max_c, idx] = time_warped_CCD(X,P,l,thresh)
	A=P{1};B=P{2};C=P{3};
	[U, S, V] = svd(C,'econ');
	all_c2 = zeros(size(A,2),1);
	for r=1:size(A,2)
        Ut = U(:,1:r);
        Ut(abs(Ut)<thresh*max(abs(Ut),[],'all'))=0;
        spUU = sparse(Ut*Ut');
        %spUU(spUU<thresh*max(spUU,[],'all'))=0;
		Xnew = sptensor(ttm(X,spUU,3));
        negs = find(Xnew<0);
        if ~isempty(negs); Xnew(negs)=0; end
		Fac.U{1} = A; Fac.U{2} = B; Fac.U{3} = sparse(spUU*C);
		Fac.lambda=ones(size(A,2),1);
        %Fac.lambda = l;
		all_c2(r) = efficient_corcondia(Xnew,Fac,1);
	end
	[max_c,idx] = max(all_c2);
    %disp(all_c2);
end

%The code for efficient CCD is taken from 
% E.E. Papalexakis and C. Faloutsos, 
% Fast efficient and scalable core consistency diagnostic for the parafac decomposition for big sparse tensors,? 
% in IEEE ICASSP 2015
%Available at https://www.cs.ucr.edu/~epapalex/src/efficient_corcondia.zip
    
